-- ----------------------------------------------------------------------------
-- MySQL Workbench Migration
-- Migrated Schemata: bdrobots
-- Source Schemata: bdejemplo
-- Created: Fri Dec 18 16:06:29 2015
-- Workbench Version: 6.3.4
-- ----------------------------------------------------------------------------

SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------------------------------------------------------
-- Schema bdrobots
-- ----------------------------------------------------------------------------
DROP SCHEMA IF EXISTS `bdrobots` ;
CREATE SCHEMA IF NOT EXISTS `bdrobots` ;

-- ----------------------------------------------------------------------------
-- Table bdrobots.mapa
-- ----------------------------------------------------------------------------
CREATE TABLE IF NOT EXISTS `bdrobots`.`mapa` (
  `idMapa` BIGINT(20) NOT NULL AUTO_INCREMENT COMMENT '',
  `nomMapa` VARCHAR(50) NULL DEFAULT 'nouMapa' COMMENT '',
  `idUsuari` BIGINT(20) NULL DEFAULT NULL COMMENT '',
  PRIMARY KEY (`idMapa`)  COMMENT '',
  INDEX `pertanyUsuari_idx` (`idUsuari` ASC)  COMMENT '',
  CONSTRAINT `pertanyUsuari`
    FOREIGN KEY (`idUsuari`)
    REFERENCES `bdrobots`.`usuari` (`idUsuari`)
    ON DELETE CASCADE
    ON UPDATE CASCADE)
ENGINE = InnoDB
AUTO_INCREMENT = 89
DEFAULT CHARACTER SET = utf8;

-- ----------------------------------------------------------------------------
-- Table bdrobots.usuari
-- ----------------------------------------------------------------------------
CREATE TABLE IF NOT EXISTS `bdrobots`.`usuari` (
  `idUsuari` BIGINT(20) NOT NULL AUTO_INCREMENT COMMENT '',
  `password` VARCHAR(45) NOT NULL COMMENT '',
  `email` VARCHAR(45) NOT NULL COMMENT '',
  `nom` VARCHAR(45) NULL DEFAULT NULL COMMENT '',
  PRIMARY KEY (`idUsuari`)  COMMENT '',
  UNIQUE INDEX `idUsuari_UNIQUE` (`idUsuari` ASC)  COMMENT '',
  UNIQUE INDEX `email_UNIQUE` (`email` ASC)  COMMENT '')
ENGINE = InnoDB
AUTO_INCREMENT = 19
DEFAULT CHARACTER SET = utf8;

-- ----------------------------------------------------------------------------
-- Table bdrobots.objectemapa
-- ----------------------------------------------------------------------------
CREATE TABLE IF NOT EXISTS `bdrobots`.`objectemapa` (
  `tipus` INT(11) NOT NULL COMMENT '',
  `posicioX` INT(11) NOT NULL COMMENT '',
  `posicioY` INT(11) NOT NULL COMMENT '',
  `idMapa` BIGINT(20) NOT NULL COMMENT '',
  PRIMARY KEY (`posicioX`, `posicioY`, `idMapa`)  COMMENT '',
  INDEX `pertanyMapa_idx` (`idMapa` ASC)  COMMENT '',
  CONSTRAINT `pertanyMapa`
    FOREIGN KEY (`idMapa`)
    REFERENCES `bdrobots`.`mapa` (`idMapa`)
    ON DELETE CASCADE
    ON UPDATE NO ACTION)
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;

-- ----------------------------------------------------------------------------
-- Table bdrobots.programa
-- ----------------------------------------------------------------------------
CREATE TABLE IF NOT EXISTS `bdrobots`.`programa` (
  `idprograma` INT(11) NOT NULL AUTO_INCREMENT COMMENT '',
  `nom` VARCHAR(45) NULL DEFAULT NULL COMMENT '',
  `codi` LONGTEXT NULL DEFAULT NULL COMMENT '',
  `idRobot` BIGINT(20) NULL DEFAULT NULL COMMENT '',
  PRIMARY KEY (`idprograma`)  COMMENT '',
  INDEX `pertanyRobot2_idx` (`idRobot` ASC)  COMMENT '')
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;

-- ----------------------------------------------------------------------------
-- Table bdrobots.robot
-- ----------------------------------------------------------------------------
CREATE TABLE IF NOT EXISTS `bdrobots`.`robot` (
  `nom` VARCHAR(45) NULL DEFAULT NULL COMMENT '',
  `posicioInicialX` INT(11) NOT NULL DEFAULT '0' COMMENT '',
  `posicioInicialY` INT(11) NOT NULL COMMENT '',
  `direccioInicial` INT(11) NULL DEFAULT NULL COMMENT '',
  `idMapa` BIGINT(20) NOT NULL COMMENT '',
  `codi` LONGTEXT NULL DEFAULT NULL COMMENT '',
  PRIMARY KEY (`posicioInicialX`, `posicioInicialY`, `idMapa`)  COMMENT '',
  INDEX `pertanyMapa_idx` (`idMapa` ASC)  COMMENT '',
  CONSTRAINT `pertanyMapa2`
    FOREIGN KEY (`idMapa`)
    REFERENCES `bdrobots`.`mapa` (`idMapa`)
    ON DELETE CASCADE
    ON UPDATE CASCADE)
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;
SET FOREIGN_KEY_CHECKS = 1;
