/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package CompilacioCodi;

import com.google.gson.Gson;
import java.util.ArrayList;
import java.util.Iterator;
import CompilacioCodi.Variable;

/**
 *Aquesta classe serveix per interpretar un codi en una cadena String i generar instruccions que es dipositaran una darrera de l'altra en un array
 * @author Xavi
 */
public class Compilador {
    private String codi="";
    private ArrayList<Variable>arrayEtiquetesVariables;
    private ArrayList<Variable>arrayPosicionsI;
    private ArrayList <Float>memoriaRAM;
    private ArrayList<Instruccio>arrayInstruccions;
    private ArrayList<CondicionalSi>arrayCondicionals;
  
    private String error;
    private int lblIndex=0;
    public Compilador(){
        arrayPosicionsI=new ArrayList<Variable>();
        memoriaRAM=new ArrayList<Float>();
        arrayInstruccions=new ArrayList<Instruccio>();
        arrayCondicionals=new ArrayList<CondicionalSi>();
//        arrayBucleMentres=new ArrayList<Integer>();
    }
    /*
      Mètode que crea un objecte Processador amb l'array de la memòria RAM ja feta i l'array de instruccions i retorna una cadena JSON 
    que s'enviarà al client.
    */
   public String getInstruccionsJSON(){
       Processador processador=new Processador(this.memoriaRAM,this.arrayInstruccions);
       Gson gson=new Gson();
       if (error!=null){
           processador.setError(error);
           return gson.toJson(processador);
       }
      return gson.toJson( processador );
   }
   /*
   Mètode que a partir de un String crea el array de instruccions. Afegeix a les línies de codi una sèrie de variables
   que van des de R0 a R9 que seran variables ja predefinides i que el codi no ha de definir i les podrà usar.
  
   */
    public void compilaCodiStr(String codiStr){
       ArrayList <String> arrayCodiStr= this.extraureInstruccionsdeString(codiStr);
        arrayCodiStr.add(0, "var R9=0");
        arrayCodiStr.add(0, "var R8=0");
         arrayCodiStr.add(0, "var R7=0");
         arrayCodiStr.add(0, "var R6=0"); 
         arrayCodiStr.add(0, "var R5=0"); 
       arrayCodiStr.add(0, "var R4=0");
        arrayCodiStr.add(0, "var R3=0");
         arrayCodiStr.add(0, "var R2=0");
         arrayCodiStr.add(0, "var R1=0"); 
         arrayCodiStr.add(0, "var R0=0"); 
//          arrayCodiStr.add(0, "var ID=0");
        ArrayList<String> array=this.extraureVariablesCodi(arrayCodiStr); 
        System.out.println("Llista de posicions instruccions: " + this.arrayPosicionsI);
        
         System.out.println("Llista de etiquetes var : " + this.arrayEtiquetesVariables);
        
      
       try{
        this.arrayInstruccions=this.compilaCodi(array);
       }catch(ExcepcioCompilacio e){
           error=e.msg;
          System.err.println(e.msg);
       }
        
       // System.out.println(this.toString());
      //  System.out.println(this.arrayInstruccions);
    }
    
    /*
    Aquest mètode el que fa és agafar el string que li és donat i crea un array de strings trimats
    per tal de que sigui més fàcil de interpretar.
    */
    private ArrayList <String> extraureInstruccionsdeString(String codiStr){
        String []array=codiStr.split("\\\n|\\;");
        ArrayList <String>arrayI=new ArrayList<String>();
        for (int i=0;i<array.length;i++){
            String s=(String)array[i];
            s=s.trim();
           // s=s.replace(" ", "");
            s= s.replaceAll("\t", "");
          
            if (!s.equals("")  ){
               arrayI.add(s);
                // System.out.println(s);
              }
          
          
        }
        return arrayI;
    }
    /*
    Aquest mètode fa diverses funcions:
        1- Llegeix del array de strings el que son variables i les separa del que és codi. Crea un array que relaciona posicions de memòria RAM 
    amb els valors.
        2- A més té en conte l'àmbit local de les variables que estan dintre de una funció (entre function i return) o dintre de lblini i lblend
        3- Llegeix del array els labels que indiquen una posició de memòria a la qual s'ha de fer un salt determinat etc com poden ser 
            les instruccions tipus 'lbl etiqueta. 
            
    */
     private ArrayList<String> extraureVariablesCodi(ArrayList <String>arrayInstruccions){
         arrayEtiquetesVariables=new ArrayList<Variable>();
        ArrayList <String>arrayI=new ArrayList<String>();
        int contadorI=0;
        int posicionsI=0;
        int variables=0;
        int functionIndex=0;
        String funcioActual="";
        Iterator it=arrayInstruccions.iterator();
        int linia=0;
       while (it.hasNext()){
            String instruccio=(String)it.next();
           
            
            
            if (instruccio.startsWith("lbl ")){
               String nomEtiqueta=instruccio.substring(3).replaceAll(" ", "");
               Variable v=new Variable(nomEtiqueta,contadorI);
               v.setSubEtiqueta(String.valueOf(this.lblIndex));
                arrayPosicionsI.add(v);
                
                System.out.println("Possicio extreta:"+this.arrayPosicionsI.get(posicionsI));
                posicionsI++;
            }else if(instruccio.startsWith("var ")){
                try{
                arrayEtiquetesVariables.add(extreuVariable(instruccio.substring(3),funcioActual));
                }catch(ExcepcioCompilacio e){
                    e.afegirAMissatge(" en linia "+linia);
                    error=e.msg;
                    System.err.println(e.msg);
                }
              //  System.out.println("Variable:"+arrayEtiquetesVariables.get(variables));
                variables++;
            }else if (instruccio.startsWith("lblini")){
                lblIndex++;
                 
            }else   if (instruccio.startsWith("lblend")){
                lblIndex--;
                 
            } else if(instruccio.startsWith(("function "))){
                String nomEtiqueta=instruccio.substring(8).replaceAll(" ", "");
               Variable v=new Variable(nomEtiqueta,contadorI);
              // v.setSubVar(String.valueOf(this.lblIndex));
                arrayPosicionsI.add(v);
                //System.out.println("Possicio extreta:"+this.arrayPosicionsI.get(posicionsI));
                posicionsI++;
                funcioActual=nomEtiqueta;
                functionIndex++;
                
                arrayI.add(instruccio);
                contadorI++;
            }else if (instruccio.startsWith(("return"))){
                functionIndex--;
                funcioActual="";
                arrayI.add(instruccio);
                contadorI++;
            }
                
            else{
             Iterator it2=this.arrayPosicionsI.iterator();
             while (it2.hasNext()){
                 Variable v=(Variable)it2.next();
                 System.out.println("VAR "+v + " " + instruccio);
                 if (instruccio.contains(v.getNom().substring(0, lblIndex))){
                     System.out.println("TROBAAAAAAAAAAAAAAAAAAAAAAAAt");
                    instruccio=instruccio.replace(v.getNom(), v.getNom()+"$"+lblIndex);
                     
                 }
             }
                arrayI.add(instruccio);
                contadorI++;
            }
            linia++;
        }
        if (functionIndex>0){
             error="Funcions no tancades amb ret";
            
        }
        return arrayI;
    }
     /*
        De una expressió tipus 'var <nomvar>=valor', crea objectes tipus Variable.
        Aquests objectes relacionen el nom que se li ha donat a una variable amb la posició dins de la memoria RAM 
        a on s'ubica dita variable.
     */
     private Variable extreuVariable(String expressio,String funcioActual) throws ExcepcioCompilacio{
    
         expressio=expressio.trim();
         
         expressio=expressio.replaceAll(" ", "");
        
       int posicioIgual= expressio.indexOf("=");
       System.err.println(posicioIgual);
       if (posicioIgual==-1)throw new ExcepcioCompilacio(" error de definicio de variable");
       String nomV=expressio.substring(0, posicioIgual);
        int valor=0;
       try{
            valor =escriureRAM(expressio.substring(posicioIgual+1)); 
     
     
       }catch(ExcepcioCompilacio e){
           
           e.afegirAMissatge(" en expressio  "+ expressio);
          // System.err.println(e.msg);
           throw e;
       }
       Variable v=new Variable(nomV,valor);
    
          
          v.setSubEtiqueta(funcioActual);
      
        return v;
        
    }
     /*
        Mètode auxiliar al mètode anterior que afegeix al array Memoria RAM el valor de la expressió que se li passa com a paràmetre
        i retorna la possició en la qual s'ha ubicat. Pot llegir de la expressió valors separats en coma i retorna la primera possició
        de memòria. Tambè pot interpretar la exprssió (n) i adjudicar el valor 0 a n posicions de memòria. 
     */
    private int escriureRAM(String expressio) throws ExcepcioCompilacio{
        String nombreEntreParentesis="\\(\\d+\\)";
        int posicioMemoria=this.memoriaRAM.size();
       // System.out.println(expressio.matches("\\(\\d+\\)"));
        if (expressio.matches(nombreEntreParentesis)){
             String [] array1=expressio.split("[()]");
             int nPosicions=Integer.parseInt(array1[1]);
             for (int g=0;g<nPosicions;g++){
                 this.memoriaRAM.add(0f);
             }
        }else{
       
            float valors[];
            String []array=expressio.split(",");
            valors=new float[array.length];
            for (int i=0;i<array.length;i++){
                String valorstr=array[i];
                if (isNumeric(valorstr)){
                   float valor= Float.parseFloat(valorstr);
                   this.memoriaRAM.add(valor);

                }else{
                    throw new ExcepcioCompilacio("Format de nombre incorrecte");
                    //System.err.println("Format de numero incorrecte");
                }
            }
        }
        return posicioMemoria;
    } 
    
    private String funcioActual="";
    
    
    private ArrayList<Instruccio> compilaCodi(ArrayList<String> instruccionsStr)throws ExcepcioCompilacio{
        ArrayList posicionsWhile=new ArrayList();
        ArrayList<Instruccio> blocInstruccions=null;
        ArrayList<Instruccio> instruccions=new ArrayList<Instruccio>();
        Iterator it=instruccionsStr.iterator();
       
        while(it.hasNext()){
           String instruccioStr=(String) it.next();
          instruccioStr= instruccioStr.replaceAll(" ", "");
           System.out.println("I: "+instruccioStr);
           Instruccio instruccio=null;
           if (instruccioStr.startsWith("add(")){
                instruccio=iOperacio("add",instruccioStr.substring(3));
              
              
           }else if (instruccioStr.startsWith("sub(")){
               instruccio=iOperacio("sub",instruccioStr.substring(3));
           }else if (instruccioStr.startsWith("mul(")){
               instruccio=iOperacio("mul",instruccioStr.substring(3));
           }else if (instruccioStr.startsWith("div(")){
                instruccio=iOperacio("div",instruccioStr.substring(3));
           }else if (instruccioStr.startsWith("mod(")){
               instruccio=iOperacio("mod",instruccioStr.substring(3));
           }else if (instruccioStr.startsWith("rnd(")){
               instruccio=iOperacio("rnd",instruccioStr.substring(3));
              
           }else if (instruccioStr.startsWith("mov(")){
             
               instruccio=iOperacio("mov",instruccioStr.substring(3));
            }else if (instruccioStr.startsWith("sin(")){
             
               instruccio=iOperacio("sin",instruccioStr.substring(3));
            }else if (instruccioStr.startsWith("cos(")){
             
               instruccio=iOperacio("cos",instruccioStr.substring(3));
            }else if (instruccioStr.startsWith("tan(")){
             
               instruccio=iOperacio("tan",instruccioStr.substring(3));
            }else if (instruccioStr.startsWith("atan(")){
             
               instruccio=iOperacio("atan",instruccioStr.substring(4));
            }else if (instruccioStr.startsWith("asin(")){
             
               instruccio=iOperacio("asin",instruccioStr.substring(4));
            }else if (instruccioStr.startsWith("acos(")){
             
               instruccio=iOperacio("acos",instruccioStr.substring(4));
            }else if (instruccioStr.startsWith("sqr(")){
             
               instruccio=iOperacio("sqr",instruccioStr.substring(3));
            }else if (instruccioStr.startsWith("pow(")){
             
               instruccio=iOperacio("pow",instruccioStr.substring(3));
            }else if (instruccioStr.startsWith("abs(")){
             
               instruccio=iOperacio("abs",instruccioStr.substring(3));
            }else if (instruccioStr.startsWith("and(")){
              
               instruccio=iOperacio("and",instruccioStr.substring(3));
                  
                 
           }else if (instruccioStr.startsWith("or(")){
              
               instruccio=iOperacio("or",instruccioStr.substring(2));
                  
                 
           }else if (instruccioStr.startsWith("comp(")){
              
               instruccio=iComparacio(instruccioStr.substring(4));
                  
                 
           }else if (instruccioStr.startsWith("jump(")){
                 instruccio=iSalt("jump",instruccioStr.substring(4));
           }else if (instruccioStr.startsWith("call(")){
               instruccio=iSalt("call",instruccioStr.substring(4));
           }else if (instruccioStr.startsWith("function")){
               instruccio=new Instruccio("empty","",null,null,null);
               this.funcioActual=instruccioStr.substring(8);
               System.out.println("FUNCIO ACTUAL=="+funcioActual);
           }
           else if (instruccioStr.startsWith("return")){
                 instruccio=iRet();
           }else if(instruccioStr.startsWith("push(")){
               blocInstruccions=iPila("push",instruccioStr.substring(4));
           }else if(instruccioStr.startsWith("pop(")){
               blocInstruccions=iPila("pop",instruccioStr.substring(3));
           }
           else if (instruccioStr.equals("end")){
                instruccio=iFi();
           } else if (instruccioStr.startsWith("forward")){
                instruccio=iDireccio("fwd",instruccioStr.substring(7));
           }else if (instruccioStr.startsWith("right")){
                instruccio=iDireccio("right",instruccioStr.substring(5));
           }else if (instruccioStr.startsWith("left")){
                instruccio=iDireccio("left",instruccioStr.substring(4));
           }else if (instruccioStr.startsWith("distance(")){
                instruccio=iDeteccio(instruccioStr.substring(8));
           }else if (instruccioStr.startsWith("switchdetect(")){
                instruccio=iDeteccioInterruptor(instruccioStr.substring(12));
           } else if (instruccioStr.startsWith("grab")){
                instruccio=iAgafarBalissa();
           } else if (instruccioStr.startsWith("put")){
                instruccio=iDeixarBalissa();
               
           }else if (instruccioStr.startsWith("object(")){
                instruccio=iObjecteFront(instruccioStr.substring(6));
               
                
               
           }else if (instruccioStr.startsWith("position(")){
                instruccio=iGPS(instruccioStr.substring(3));
            }else if (instruccioStr.startsWith("compass(")){
                instruccio=iCompass(instruccioStr.substring(7));
            }else if (instruccioStr.startsWith("switchstate(")){
                instruccio=iEstatInterruptor(instruccioStr.substring(11));
            }
           else if (instruccioStr.startsWith("painton")){
                instruccio=new Instruccio("paint","on",null,null,null);
               
           }else if (instruccioStr.startsWith("paintoff")){
                instruccio=new Instruccio("paint","off",null,null,null);
               
           }  else if (instruccioStr.startsWith("whiteinfront(")){
                //instruccio=new Instruccio("WHITEINFRONT","",null,null,null);
               instruccio=iWhiteinFront(instruccioStr.substring(12));
               
           }  else if (instruccioStr.startsWith("send(")){
                //instruccio=new Instruccio("WHITEINFRONT","",null,null,null);
               instruccio=iComunicacio("send",instruccioStr.substring(4));
               
           }   else if (instruccioStr.startsWith("receive(")){
                //instruccio=new Instruccio("WHITEINFRONT","",null,null,null);
               instruccio=iComunicacio("rcv",instruccioStr.substring(7));
               
           }  else if (instruccioStr.startsWith("cansend(")){
                //instruccio=new Instruccio("WHITEINFRONT","",null,null,null);
               instruccio=iComunicacio("csend",instruccioStr.substring(7));
               
           }       
           else if(instruccioStr.startsWith("if(")){
               
                 CondicionalSi csi=new CondicionalSi();
               if (esExpressioAND(instruccioStr.substring(2))){
                        System.out.println("ES UNA CONJUNTIVA");
                        blocInstruccions=this.extrauExpressions("and",instruccioStr.substring(2));
                        csi.setConjuntiva();
               }else if(esExpressioOR(instruccioStr.substring(2))){
                      
                        blocInstruccions=this.extrauExpressions("or",instruccioStr.substring(2)); 
                       // Instruccio buida=new Instruccio("BUIDA","",null,null,null);
                      //  blocInstruccions.add(buida);
                        int posMemoriaDespresSalts=instruccions.size()+blocInstruccions.size();
                        System.out.println("ES UNA DISJUNTIVA "+posMemoriaDespresSalts );
                       for(int j=0;j<blocInstruccions.size()-1;j++){
                           Instruccio i=blocInstruccions.get(j);
                             Operand op=new Operand(1,0f,posMemoriaDespresSalts,0); 
                           i.setOperand1(op);
                       }
                        csi.setDisjuntiva();
               }else{
                    blocInstruccions=this.extrauExpressions("and",instruccioStr.substring(2));
                    csi.setConjuntiva();
               }
              
              
              
                
                csi.setSiInstruccions(blocInstruccions);
                this.arrayCondicionals.add(csi); 
                
               
//              // instruccio=avaluaComparacioSalt(instruccioStr.substring(2),true);
//               CondicionalSi csi=new CondicionalSi();
//               csi.setPosicioInstruccioSI(instruccions.size());
//               this.arrayCondicionals.add(csi);
           }else if(instruccioStr.startsWith("else")){
            
                instruccio=new Instruccio("jump","alw",null,null,null);
                CondicionalSi csi=this.arrayCondicionals.get(this.arrayCondicionals.size()-1);
                 ArrayList siInstruccions= csi.getSiInstruccions();
                 Operand op=new Operand(1,0f,instruccions.size()+1,0);
               if (csi.getLogica()==CondicionalSi.CONJUNTIVA) {
                   CondicionalSi.setOperand1AInstruccions(op, siInstruccions);
               }
               if (csi.getLogica()==CondicionalSi.DISJUNTIVA){
                   Instruccio i=(Instruccio)csi.getSiInstruccions().get(csi.getSiInstruccions().size()-1);
                  i.setOperand1(op);
               }
                csi.setSinoInstruccio(instruccio);
               
                /*
               CondicionalSi csi=this.arrayCondicionals.get(this.arrayCondicionals.size()-1);
               csi.setPosicioInstruccioSINO(instruccions.size());
               Instruccio ins=instruccions.get(csi.getPosicioInstruccioSI());
                    Operand op=new Operand(1,0f,instruccions.size()+1,0);
                    ins.setOperand1(op);
                */
           }
          
           else if(instruccioStr.startsWith("endif")){
               System.out.println("FFFIIIISIIIIII");
                CondicionalSi csi=this.arrayCondicionals.get(this.arrayCondicionals.size()-1);
                if (csi.getSinoInstruccio()!=null){
                    Instruccio instruccioSINO=csi.getSinoInstruccio();
                     Operand op=new Operand(1,0f,instruccions.size(),0);
                    instruccioSINO.setOperand1(op);
                }else{
                     ArrayList siInstruccions= csi.getSiInstruccions();
                     Operand op=new Operand(1,0f,instruccions.size(),0); 
                     if (csi.getLogica()==CondicionalSi.CONJUNTIVA) System.out.println("CCCCCCCCCCCCCCCCCCCCCCCCCCCC");CondicionalSi.setOperand1AInstruccions(op, siInstruccions);
                    if (csi.getLogica()==CondicionalSi.DISJUNTIVA){
                        System.out.println("DISSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS");
                        Instruccio i=(Instruccio)csi.getSiInstruccions().get(csi.getSiInstruccions().size()-1);
                       i.setOperand1(op);
                    }
                }
                 if(this.arrayCondicionals.size()>0){
                    this.arrayCondicionals.remove(this.arrayCondicionals.size()-1);
                }else{
                    return null;
                }
               instruccio=new Instruccio("empty","",null,null,null);
               /*
               CondicionalSi csi=this.arrayCondicionals.get(this.arrayCondicionals.size()-1);
               if (csi.getPosicioInstruccioSINO()!=-1){
                    Instruccio ins2=instruccions.get(csi.getPosicioInstruccioSINO());
                    Operand op2=new Operand(1,0f,instruccions.size(),0);
                    System.out.println("instruccio SINO" + ins2);
                    ins2.setOperand1(op2);
               }else{
                  
                    Instruccio ins=instruccions.get(csi.getPosicioInstruccioSI());
                    Operand op=new Operand(1,0f,instruccions.size(),0);
                    ins.setOperand1(op);
               }
          
             if(this.arrayCondicionals.size()>0){
                 this.arrayCondicionals.remove(this.arrayCondicionals.size()-1);
             }else{
                 return null;
             }
              
               instruccio=new Instruccio("BUIDA","",null,null,null);
               
               */
           }else if(instruccioStr.startsWith("write(")){
              instruccio= iEscriu(instruccioStr.substring(5));
               
           }else if(instruccioStr.startsWith("while(")){
               
              // BucleMentres bm=new BucleMentres(instruccions.size(),instruccioStr.substring(5));
               instruccio=this.avaluaComparacioSalt(instruccioStr.substring(5), true);
               
               posicionsWhile.add(instruccions.size());
              
           }else if(instruccioStr.startsWith("endwhile")){
               int posWhile=(int)posicionsWhile.get(posicionsWhile.size()-1);
            
               Operand op1=new Operand(1,0f,posWhile,0);
               instruccio=new Instruccio("jump","alw",op1,null,null);
              Instruccio instruccioWhile= instruccions.get(posWhile);
              instruccioWhile.setOperand1(new Operand(1,0f,instruccions.size()+1,0));
              
              
//              // BucleMentres bm=arrayBucleMentres.get(arrayBucleMentres.size()-1);
//               System.out.println("Buclementres " + bm);
//               System.out.println("BBBBUUUCCLLEEEE "+ bm.getExpressio());
//                instruccio=avaluaComparacioSalt(bm.getExpressio(),false);
//                if (instruccio!=null){
//                instruccio.setOperand1(new Operand(1,0f,bm.getPosicioMemoria(),0));
//                }
                posicionsWhile.remove(posicionsWhile.size()-1);
           }
           
          
           if (blocInstruccions!=null){
               Iterator iter=blocInstruccions.iterator();
            
               while(iter.hasNext()){
                   Instruccio i=(Instruccio)iter.next();
                  
                    if (i!=null){
                     
                        instruccions.add(i);
                    }else{
                        throw new ExcepcioCompilacio("Instruccio "+ instruccioStr + " té una sintàxia errònea o un dels operadors son erronis o fan referència a una variable no definida." ); 

                    }
               }
               blocInstruccions=null;
           }else{
               if (instruccio!=null){
                   instruccions.add(instruccio);
               }else{
                   throw new ExcepcioCompilacio("Instruccio "+ instruccioStr + " té una sintàxia errònea o un dels operadors son erronis o fan referència a una variable no definida." ); 

               }
           }
          
        }
      if (instruccions.size()>0){
            return instruccions;
      }else{
          throw new ExcepcioCompilacio("No hi han instruccions" ); 
              
      }
    }
    private boolean  esExpressioAND(String expressio){
        String []expressions=expressio.split("Y");
        if (expressions.length>1)return true;
        return false;
    }
    private boolean  esExpressioOR(String expressio){
        String []expressions=expressio.split("O");
        if (expressions.length>1)return true;
        return false;
    }
    public ArrayList<Instruccio>  extrauExpressions(String operadorLogic,String expressio){
        ArrayList llistaInstruccions=new ArrayList();
        String [] expressions=null;
        if (operadorLogic.equals("and"))expressions=expressio.split("Y");
         if (operadorLogic.equals("or"))expressions=expressio.split("O");
        System.out.println("&&&&& ");
        mostraArray("&&&&&&",expressions);
        if (expressions.length>0){
            mostraArray("Expressions" , expressions);
            for (int i=0;i<expressions.length;i++){ 
                Instruccio instruccio;
                if (operadorLogic.equals("or") && i<expressions.length-1){
                   instruccio=avaluaComparacioSalt(expressions[i],false);
                }else{
                      instruccio=avaluaComparacioSalt(expressions[i],true);
                }
                if (instruccio!=null){
                    llistaInstruccions.add(instruccio);
                }else{
                    return null;
                }
            }
            return llistaInstruccions;
        }else{
             Instruccio instruccio=avaluaComparacioSalt(expressio,true);
             if (instruccio!=null){
                llistaInstruccions.add(instruccio);
                return llistaInstruccions;
             }else{
                 return null;
             }  
             
        }
    }
    
    private Instruccio iAgafarBalissa(){
        Instruccio instruccio=new Instruccio("action","grab",null,null,null);
        return instruccio;
    }
    private Instruccio iDeixarBalissa(){
        Instruccio instruccio=new Instruccio("action","put",null,null,null);
        return instruccio;
    }
    private Instruccio iCompass(String expressio){
         String [] operandsStr=expressio.split("[(,)]");
       
         if (operandsStr.length==2){
              Operand op1=this.getOperandExpressio(operandsStr[1]); 
              if (op1!=null){
                  Instruccio instruccio=new Instruccio("compass","",op1,null,null);
                  return instruccio;
              }
         }
         return null;
    }
    private Instruccio iEstatInterruptor(String expressio){
         String [] operandsStr=expressio.split("[(,)]");
       System.out.println("INTERRUPTOR "+operandsStr.length);
         if (operandsStr.length==4){
              Operand op1=this.getOperandExpressio(operandsStr[1]); 
              Operand op2=this.getOperandExpressio(operandsStr[2]); 
              Operand op3=this.getOperandExpressio(operandsStr[3]);  
               
              if (op1!=null && op2!=null && op3!=null){
                  Instruccio instruccio=new Instruccio("switch","estate",op1,op2,op3);
                  return instruccio;
              }
         }
         return null;
    }
    private Instruccio iGPS(String expressio){
         String [] operandsStr=expressio.split("[(,)]");
         if (operandsStr.length==3){
             Operand op1=this.getOperandExpressio(operandsStr[1]);
             Operand op2=this.getOperandExpressio(operandsStr[2]);
             if (op1!=null && op2!=null){
                 Instruccio instruccio=new Instruccio("loc","",op1,op2,null);
                 return instruccio;
             } 
         }
         return null;
    }
    private Instruccio iObjecteFront(String expressio){
        String [] operandsStr=expressio.split("[(,)]");
        if (operandsStr.length==4){
             Operand op1=this.getOperandExpressio(operandsStr[1]);
             Operand op2=this.getOperandExpressio(operandsStr[2]);
           
             if (op1!=null && op2!=null &&  ( operandsStr[3].equals("-1") || operandsStr[3].equals("0")|| operandsStr[3].equals("1"))){
                 Instruccio instruccio=new Instruccio("detect","obj",op1,op2,new Operand(0,Float.parseFloat( operandsStr[3]),0,0));
                 return instruccio;
                 
             }
        }
        
        return null;
    }
    private Instruccio iDeteccioInterruptor(String expressio){
        String [] operandsStr=expressio.split("[()]");
        if (operandsStr.length==2){
             Operand op1=this.getOperandExpressio(operandsStr[1]);
             if (op1!=null){
                 Instruccio instruccio=new Instruccio("detect","switch",op1,null,null);
                 return instruccio;
                 
             }
        }
        
        return null;
    }
    private Instruccio iEscriu(String expressio){
        String [] operandsStr=expressio.split("[()]");  
        Instruccio instruccio=new Instruccio("ESCRIU",operandsStr[1],null,null,null);
        return instruccio;
    }
    
    private Instruccio avaluaComparacioSalt(String expressio,boolean contrari){
          String [] operandsStr=expressio.split("[()]");  
           ArrayList splitComparadors=this.splitComparacio(operandsStr[1],contrari);
                 if (splitComparadors!=null){
                    //System.out.println(splitComparadors.get(0));
                    String [] arrayOp=(String[])splitComparadors.get(1);
                    
                    mostraArray("Comparadors ",(String[])splitComparadors.get(1));
                    Operand op2=getOperandExpressio(arrayOp[0]);
                    Operand op3=getOperandExpressio(arrayOp[1]);
                    if (op3!=null && op2!=null){
                       
                        Instruccio instruccio=new Instruccio("jump",(String)splitComparadors.get(0),null,op2,op3);
                        System.out.println(instruccio);
                        return instruccio;
                    }
                    
                 }else{
                   
                     System.err.println("Comparacio erronea");  
                    
                 }
                 return null;
    } 
    private ArrayList <Instruccio> iPila(String operacio,String expressio){
        ArrayList <Instruccio> bloc=new ArrayList<Instruccio>();
         String [] operandsStr=expressio.split("[(,)]");  
         this.mostraArray("Piles", operandsStr);
         if (operandsStr.length>1){
                for(int i=1;i<operandsStr.length;i++){
                    Operand op1=this.getOperandExpressio(operandsStr[i]);
                     if (op1!=null){
                         Instruccio instruccio=new Instruccio("stack",operacio,op1,null,null);
                         bloc.add(instruccio);
                         
                       }else{
                         return null;
                     }
                         
                         
                 }
                if (bloc.size()>0){
                    return bloc;
                }
                
                   
                
            
         }
         return null;
    }
    
    private Instruccio iRet(){
        Instruccio instruccio=new Instruccio("ret","",null,null,null);
        return instruccio;
    }
      private Instruccio iFi(){
        Instruccio instruccio=new Instruccio("end","",null,null,null);
        return instruccio;
    }
      private Instruccio iComparacio(String expressio){
            String [] operandsStr=expressio.split("[(,)]");  
            if (operandsStr.length==3){
                Operand op1=this.getOperandExpressio(operandsStr[1]);
                
                if (op1!=null){
                     ArrayList splitComparadors=this.splitComparacio(operandsStr[2],false);
                     System.out.println("SPLIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIT"+splitComparadors);
                    if (splitComparadors!=null){
                        
                            String [] arrayOp=(String[])splitComparadors.get(1);
                             Operand op2=getOperandExpressio(arrayOp[0]);
                            Operand op3=getOperandExpressio(arrayOp[1]);
                            if (op3!=null && op2!=null){
                                Instruccio instruccio=new Instruccio("cmp",(String)splitComparadors.get(0),op1,op2,op3);
                                return instruccio;
                            }
                      }
                }
            }
          return null;
      }
    private Instruccio iOperacio(String operacio,String instruccioStr){
        //System.out.println(instruccioStr);
        String [] operandsStr=instruccioStr.split("[(,)]");
//        for (int i=0;i<operandsStr.length;i++){
//            System.out.println(operandsStr[i]);
//        }
       
        if (operandsStr.length==3 && (  operacio.equals("abs") || operacio.equals("sqr") || operacio.equals("mov") || operacio.equals("sin")|| operacio.equals("cos")|| operacio.equals("tan") || operacio.equals("asin")|| operacio.equals("acos")|| operacio.equals("atan"))){
          
            Operand op1=getOperandExpressio(operandsStr[1]);
            Operand op2=getOperandExpressio(operandsStr[2]);
            if (op1!=null && op2!=null){
                Instruccio instruccio=new Instruccio("op",operacio,op1,op2,null);
                return instruccio;
            }
        }
       
        if (operandsStr.length==4){
         
            Operand op1=getOperandExpressio(operandsStr[1]);
            Operand op2=getOperandExpressio(operandsStr[2]);
            Operand op3=getOperandExpressio(operandsStr[3]); 
            if (op1!=null && op2!=null && op3!=null){
                
                Instruccio instruccio=new Instruccio("op",operacio,op1,op2,op3);
            System.out.println(instruccio);
            return instruccio;
            }else{
                return null;
              
            }
            
        }
        return null;
    }
    
    private Instruccio iSalt(String tipus,String instruccioStr){ 
     
         String [] operandsStr=instruccioStr.split("[(,)]");  
         mostraArray("operands de salt",operandsStr);
         
         if (operandsStr.length==2){
              int posicioSalt=getPosicioCodi(operandsStr[1]);
             Operand op1=new Operand(1,0f,posicioSalt,0);
             if (posicioSalt!=-1){
                   Instruccio instruccio=new Instruccio(tipus,"alw",op1,null,null);
                    System.out.println(instruccio);
                    return instruccio;
             }else{
                 System.err.println("Salt a una posicio no determinada");
             }
         }
         if (operandsStr.length==3){
             int posicioSalt=getPosicioCodi(operandsStr[1]);
             Operand op1=new Operand(1,0f,posicioSalt,0);
          //   Operand op1 =getOperandExpressio(operandsStr[2]);
             if (posicioSalt!=-1){
               //  operandsStr[2].split("[\\=\\<");
                 System.out.println("SALT A " + posicioSalt);
                 
                 ArrayList splitComparadors=this.splitComparacio(operandsStr[2],false);
                 if (splitComparadors!=null){
                    System.out.println(splitComparadors.get(0));
                    String [] arrayOp=(String[])splitComparadors.get(1);
                    
                    mostraArray("Comparadors ",(String[])splitComparadors.get(1));
                    Operand op2=getOperandExpressio(arrayOp[0]);
                    Operand op3=getOperandExpressio(arrayOp[1]);
                    if (op3!=null && op2!=null){
                       
                        Instruccio instruccio=new Instruccio(tipus,(String)splitComparadors.get(0),op1,op2,op3);
                        System.out.println(instruccio);
                        return instruccio;
                    }
                    
                 }else{
                     System.err.println("Comparacio erronea");
                 }
                 
             }
             else{
                 System.err.println("Salt a una posicio no determinada");
             }
         }
         return null;
    }
    private Instruccio iDireccio(String tipus,String expressio){
        Instruccio instruccio = new Instruccio("action",tipus,null,null,null);
        return instruccio;
//         String nombreEntreParentesis="\\(\\d+\\)";
//         String [] operandsStr=expressio.split(nombreEntreParentesis);  
//         if (expressio.matches(nombreEntreParentesis)){
//             String [] array1=expressio.split("[()]");
//             float pasos=Float.parseFloat(array1[1]);
//             Instruccio instruccio=new Instruccio("action",tipus,new Operand(0,pasos,0,0),null,null);
//             return instruccio;
//         }else{
//             return null;
//         }
        
    }
    private Instruccio iWhiteinFront(String expressio){
         String [] operandsStr=expressio.split("[()]");
        if (operandsStr.length==2){
             Operand op1=this.getOperandExpressio(operandsStr[1]);
             if (op1!=null){
                 Instruccio instruccio=new Instruccio("detect","white",op1,null,null);
                 return instruccio;
                 
             }
        }
        
        return null;
    }
     private Instruccio iComunicacio(String operacio,String expressio){
         String [] operandsStr=expressio.split("[(,)]");
         
         if (operandsStr.length==2 &&  operacio.equals("csend")){
             Operand op1=this.getOperandExpressio(operandsStr[1]);
            
             if (op1!=null  ){
                 Instruccio instruccio=new Instruccio("comm",operacio,op1,null,null);
                 return instruccio;
                 
             }
         }
         if (operandsStr.length==3 && (operacio.equals("rcv") ||  operacio.equals("send"))){
             Operand op1=this.getOperandExpressio(operandsStr[1]);
             Operand op2=this.getOperandExpressio(operandsStr[2]);
             if (op1!=null && op2!=null ){
                 Instruccio instruccio=new Instruccio("comm",operacio,op1,op2,null);
                 return instruccio;
                 
             }
        }
//        if (operandsStr.length==4 && operacio.equals("SEND")){
//             Operand op1=this.getOperandExpressio(operandsStr[1]);
//              Operand op2=this.getOperandExpressio(operandsStr[2]);
//               Operand op3=this.getOperandExpressio(operandsStr[3]);
//             if (op1!=null && op2!=null && op3!=null){
//                 Instruccio instruccio=new Instruccio("COMUNICACIO",operacio,op1,op2,op3);
//                 return instruccio;
//                 
//             }
//        }
        
        
        return null;
    }
    private Instruccio iDeteccio(String expressio){
         String [] operandsStr=expressio.split("[(,)]");
         if (operandsStr.length==3){
             
             
              if (operandsStr[2].equals("-1") || operandsStr[2].equals("0")|| operandsStr[2].equals("1")){
                   Operand op1=getOperandExpressio(operandsStr[1]);
                   Operand op2=new Operand(0,Float.parseFloat( operandsStr[2]),0,0);
                   if (op1!=null && op2!=null){
                       Instruccio instruccio=new Instruccio("detect","dist",op1,op2,null);
                       return instruccio;
                   }
              }
         }
         return null;
    }
    private Operand getOperandExpressio(String operandStr){
        operandStr=operandStr.replaceAll(" ", "");
        System.out.println("Str de operand "+operandStr);
       if (!isNumeric(operandStr)){
           
           System.out.println("");
           String []array=operandStr.split("[\\[*\\]]");
           mostraArray("Split del operand " + operandStr,array);
           if (array.length==1){
              int posMem= getPosicioMemoria(array[0]);
              if (posMem!=-1){
                  Operand op=new Operand(1,0f,posMem,0);
                  return op;
              }else{
                 
                  System.out.println("Error no s'ha trobat referencia");
              }
           }
           if (array.length==2){
               if (!this.isNumeric(array[1])){
                    int posMem= getPosicioMemoria(array[0]);
                    int indexMem=getPosicioMemoria(array[1]);
                     
                    if (posMem!=-1 && indexMem!=-1){ 
                        //float valorMem=this.memoriaRAM.get(indexMem);
                      //  Operand op=new Operand(2,0f,posMem,(int)valorMem);
                         Operand op=new Operand(2,0f,posMem,indexMem);
                        return op;
                    }else{
                        System.out.println("Error no s'ha trobat referencia");
                    }
               }else{
                    int posMem= getPosicioMemoria(array[0]);
                    int indexMem=Integer.parseInt(array[1]);
                  
                    if (posMem!=-1){
                         Operand op=new Operand(3,0f,posMem,indexMem);
                         
                         return op;
                    }else{
                        System.out.println("Error no s'ha trobat referencia");
                    }
                    
               }
           }
       }else{
           System.out.println("Es un nombre ");;
           Operand op=new Operand(0,Float.parseFloat(operandStr),0,0);
           return op;
       }
       return null;
    }
    private int getPosicioMemoria(String etiqueta){
        Iterator it=arrayEtiquetesVariables.iterator();
        int i=0;
        while(i<arrayEtiquetesVariables.size()){
            Variable v=(Variable)arrayEtiquetesVariables.get(i);
            System.out.println("vvvvvvvvvvvvvvv "+etiqueta+"   "+v.getNom() + " "+v.getValor() +"  subet:"+  v.getSubEtiqueta());
            if (i<10){
               if (v.getNom().equals(etiqueta) ){
              
                return v.getValor();
            } 
            }else{
            if (v.getNom().equals(etiqueta) && v.getSubEtiqueta().equals(this.funcioActual)){
               System.out.println("trobaaaaaaat");
                return v.getValor();
            }
            }
            i++;
        }
        return -1;
    }
    private int getPosicioCodi(String etiqueta){
        Iterator it=this.arrayPosicionsI.iterator();
        while(it.hasNext()){
            Variable v=(Variable)it.next();
          //  System.out.println("vvvvvvvvvvvvvvv "+etiqueta+"   "+v.getNom() + " "+v.getValor());
            System.out.println(etiqueta);
            String [] arrayEt=etiqueta.split("[$]");
            System.out.println(arrayEt.length);
            
            String nomEtiqueta=arrayEt[0];
            if (arrayEt.length>1){
                String nomSubEtiqueta=arrayEt[1];
                System.out.println(nomEtiqueta + "   "+nomSubEtiqueta);
    //            String numeroSubEt=etiqueta.substring(v.getNom().length()-1,)
                if (v.getNom().equals(nomEtiqueta) && nomSubEtiqueta.equals(v.getSubEtiqueta())  ){

                    return v.getValor();
                } 
            }else{
                if (v.getNom().equals(nomEtiqueta)  ){

                    return v.getValor();
                } 
            }
        }
        return -1;
    }
    public ArrayList splitComparacio(String expressio,boolean contrari){
        String comparadors[]={"<","<=",">",">=","=","<>"};
        boolean trobat=false;
        for (int i=0;i<comparadors.length;i++){
             String split[]=expressio.split(comparadors[i]);
             if (split.length==2  ){
                
                    if (!split[0].contains(">") && !split[0].contains("<") &&  !split[0].contains("=") &&!split[1].contains(">") && !split[1].contains("<") &&  !split[1].contains("=") ){
                        System.out.println("Comparadors: ");
                        System.out.println(split[0]+ "   " + split[1] +  "   " + comparadors[i]);
                        
                         ArrayList array=new ArrayList();
                        array.add(getLiteralComparador(comparadors[i],contrari));
                        array.add(split);
                        
                        return array;
                        
                    
                 }
             }
        }
        return null;
    }
     public ArrayList splitComparacio2(String expressio,boolean contrari){
        String comparadors[]={"[<]","[<][=]","[>]","[>][=]","[=]","[<>]"};
       for (int i=0;i<comparadors.length;i++){ 
            String split[]=expressio.split(comparadors[i]);
            System.out.println("Operadors trobats en split");
            for (int k=0;k<split.length;k++){
                System.out.println("op: "+split[k]);
            }
            if (split.length==2 && !split[1].startsWith("=") && !split[1].startsWith(">")){
                ArrayList array=new ArrayList();
                
                array.add(getLiteralComparador(comparadors[i],contrari));
                array.add(split);
                return array;

            }
             
       }
        return null;
    }
     private String getLiteralComparador(String comparacio,boolean contrari){
         if (comparacio.equals("<")){
             if (contrari){
                 return ">=";
             }else{
                 return "<";
             }
         }else if(comparacio.equals("<=")){
             if (contrari){
                 return ">";
             }else{
                 return "<=";
             }
            
         }else if(comparacio.equals(">")){
             if (contrari){
                 return "<=";
             }else{
                 return ">";
             }
           
         }else if(comparacio.equals(">=")){
             if (contrari){
                 return "<";
             }else{
                 return ">=";
             }
            
         }else if(comparacio.equals("=")){
             if (contrari){
                 return "!=";
             }else{
                 return "=";
             }
         } else if(comparacio.equals("<>")){
             if (contrari){
                 return "=";
             }else{
                 return "!=";
             }
            
            
         }else{
             return null;
         }
     }
    public void mostraArray(String titol,String array[]){
        System.out.println(titol);
        for (int i=0;i<array.length;i++){
            System.out.println(i+" - "+array[i]);
        }
    }
    public String toString(){
        
        String str="";
        
        Iterator it=this.memoriaRAM.iterator();
        int i=0;
        while(it.hasNext()){
            Float valor=(Float)it.next();
            str+="RAM "+ i + " valor: " + valor+"\n";
           
            i++;
        }
        it =this.arrayEtiquetesVariables.iterator();
        while(it.hasNext()){
            Variable v=(Variable)it.next();
            str+="Etiqueta "+v.getNom()+ " - "+v.getValor()+"\n";
        }
        System.out.println("Instruccions:");
        it =this.arrayInstruccions.iterator();
        while(it.hasNext()){
            Instruccio ins=(Instruccio)it.next();
            str+=ins.toString()+"\n";
        }
        return str;
    }
    public boolean isNumeric(String s) {  
            return s.matches("[-+]?\\d*\\.?\\d+");  
    }  
    public static void main(String args[]){
        Compilador compilador=new Compilador();
        /*
        String codiStr="   var n=1,2.5, 5,  10 \n";
        codiStr+="  var resultat=(   4)  \n";
        codiStr+="var index=1 \n";
      //  codiStr+="push(5)\n";
      //    codiStr+="push(resultat[1])\n";
         codiStr+="call(funcio1,index=5)\n";
        codiStr+="   lbl inici  \n";
        codiStr+="   sum  (  resultat[index ],  n[index],2)   \n";
        
        codiStr+="    var   hj=4,8\n";
       
        codiStr+= "   div(index,index,1)  \n "; 
        codiStr+="  lbl   merdi   \n";
        codiStr+="   salt (  inici, index<=4);";
        codiStr+=" salt(merdi,index=6)  \n";
        codiStr+="salt (merdi)\n";
         codiStr+="detecta(resultat[index],-1) \n";
          codiStr+="endavant(1) \n";
        codiStr+=" fi ;";
        codiStr+="lbl funcio1;";
        codiStr+="var param1=0;";
        codiStr+="var param2=0;";
        codiStr+="var result=0;";
        codiStr+="sum (result,param1,param2);";
         codiStr+="ret;";
       */
//        String codiStr="var index=0;";
//         codiStr+="lblini \n";
//        
//          codiStr+="lbl repeteix \n";
//          
//          codiStr+="salt(repeteix,index<5) \n";
//          codiStr+="lblend \n";
      //  compilador.compilaCodiStr(codiStr);
//          compilador.splitComparacio("num1<num2", true);
//         String []array= "i<>4".split(">");
//         
//         compilador.mostraArray("Split",array);
//         compilador.splitComparacio2("i<>3", true);
//         System.out.println(array[0].contains(">"));
       // System.out.println(compilador.toString());
       // System.out.println(compilador.getInstruccionsJSON());
      /*    
        String codiStr="var a=1 ;";
           codiStr+="var b=5 ;";
          codiStr+="var c=9;";
          codiStr+="endavant(1);";
         codiStr+="si (a<2)   \n";
         codiStr+="endavant(1);";
         codiStr+="sino;";
         codiStr+="endavant(2);";
         codiStr+="fisi";
        compilador.compilaCodiStr(codiStr);
        System.out.println(compilador.toString());
        */ 
        String codiStr="var a=1 ;";
           codiStr+="var b=5 ;";
              codiStr+="sum(a,b,b);";
              codiStr+="call(Funcio1);";
          codiStr+="function Funcio1;";
         codiStr+="var r=0;";
          codiStr+="var b=6;"; 
          codiStr+="sum(r,b,b);";
          codiStr+="return;";
         
          
       compilador.compilaCodiStr(codiStr);
          System.out.println(compilador.toString());
    }
}
